#include <16F88.h>
#device ADC=8
#use delay(clock=8000000)
#use fast_io(B)
#fuses INTRC_IO,NOBROWNOUT,NOPROTECT,NOCPD,NOLVP,NOWDT,NOMCLR,NOPUT,NOIESO,NOFCMEN
//#OPT compress

//#INCLUDE <stdlib.h> 

#USE TIMER(TIMER=1,TICK=1us,BITS=16,NOISR) 

//#rom  0x2100={0,0,0,0,0,30}


#define    mod0tus      !input(PIN_A2)   
#define    mod1tus      !input(PIN_A1)   
#define    mod2tus      !input(PIN_A3)   

#define    actus        !input(PIN_A4)
#define    kapatus      !input(PIN_A5)

#define    TONE_PIN    PIN_A6




//************************************************
#INT_TIMER2 
void timer2_isr(){
   //intsayisi++;
}
//************************************************
unsigned int16 tick_difference(unsigned int16 current, unsigned int16 previous) 
{
   return(current - previous); 
} 
//-----------------------------------------
void beep(int16 period){
   while((period--) != 0)
   {
      output_high(TONE_PIN);
      delay_ms(2);
      output_low(TONE_PIN);
      delay_ms(2);
   }
}
//-----------------------------------------
void main ( )
{
unsigned int16 current_tick, previous_tick; 
int mode, ledval, portval;
int servokonum, oncekiadc,gunceladc;
int modtus0basili,modtus1basili,modtus2basili,ayartusta;
int16 sayac, sayac2;
int sayac3;


setup_comparator (NC_NC_NC_NC);
SETUP_WDT (WDT_2304MS);
setup_oscillator(OSC_8MHZ);
//port_b_pullups(0b01000000);

SETUP_ADC_PORTS(sAN0);
setup_adc(ADC_CLOCK_INTERNAL);            
set_adc_channel(0);  


current_tick = previous_tick = get_ticks(); 

//setup_timer_2(T2_DIV_BY_1,6,8); 
set_tris_b(0b00000000);
//calsmode = read_eeprom(5);
//enable_interrupts(INT_TIMER1); 
//enable_interrupts(GLOBAL); 
//if(RESTART_CAUSE()==NORMAL_POWER_UP) kaydir(); 
mode = 1;
servokonum=89;
sayac=300;
sayac2=3000;
portval=0b00000010; 
ledval=0b00000001;  
output_low(pin_a7);  

/*while(TRUE) { 
restart_wdt();
output_toggle(tone_pin);
delay_ms(500);
}*/
 
while(TRUE) { 
restart_wdt();
current_tick = get_ticks();

//-----------------------------

   //if(actus && actusbasili!=1) {
   if(actus) {
      //output_toggle(pin_a7);
      if(servokonum > 0 && sayac3--==0) { 
         servokonum--;
         //beep(2);
         sayac3=100;
      }
      ayartusta=1;
      //actusbasili=1;
   }

   //if(!actus) actusbasili=0;
      
   
//-----------------------------   
   

   //if(kapatus && kapatusbasili!=1) {
   if( kapatus ) {
      //output_toggle(pin_a7);
      if(servokonum < 100 && sayac3--==0) {
         servokonum++;
         //beep(2);
         sayac3=100;
      }
      ayartusta=1;
      //kapatusbasili=1;
   }
   //if(!kapatus) kapatusbasili=0;
   


//-----------------------------


   if(mod0tus && modtus0basili!=1) {
      output_toggle(pin_a7);
      modtus0basili=1;
      //beep(5);
   }
   if(!mod0tus) modtus0basili=0;


//-----------------------------


   if(mod1tus && modtus1basili!=1) {
      ayartusta=1;
      if(servokonum!=40) servokonum=40;
      else servokonum=89;
      //servokonum=50;
      modtus1basili=1;
      //beep(5);
   }
   if(!mod1tus) modtus1basili=0;


//-----------------------------
 

   if(mod2tus && modtus2basili!=1) {
      ayartusta=1;
      if(servokonum!=0) servokonum=0;
      else servokonum=89;
      //servokonum=100;
      modtus2basili=1;
      //beep(5);
   }
   if(!mod2tus) modtus2basili=0;


//-----------------------------


   if(mode==1){
         if(tick_difference(current_tick, previous_tick) >  (1000+(int16)servokonum*10)) { 
            //output_low(PIN_B0);
            bit_clear(portval,0);
            output_b(portval);
            previous_tick = current_tick; 
            mode=0;
         }
   }
   

//-----------------------------  
   
   
   if(mode==0){
         //if(tick_difference(current_tick, previous_tick) >  (19000-(int16)servokonum*10)) { 
         if(tick_difference(current_tick, previous_tick) >  (19000-(int16)servokonum*10)) { 
            //output_high(PIN_B0); 
            bit_set(portval,0);
            output_b(portval);
            previous_tick = current_tick; 
            mode=1;
         }
   }
      
      
//-----------------------------      
      
      
   if(sayac-- == 0 ) {
      if( ayartusta==0 )
      {  
         oncekiadc=read_adc();
         servokonum=oncekiadc/2.2;
         //servokonum=read_adc()/2.2;
         if (servokonum>100) servokonum=100;
      }
      else
      {
         gunceladc=read_adc();
         if(read_adc()>250) ayartusta=0;
         //if(abs(oncekiadc-gunceladc)>50)ayartusta=0;
         oncekiadc=gunceladc;
      }
      sayac = 300;
   }
 
//-----------------------------  
  
   if(sayac2-- == 0){
      ledval=ledval<<1;
      portval = ledval + (portval&0b00000001);
      output_b(portval);
      if(ledval==0b10000000) ledval=0b00000001;
      beep(1);
      sayac2 = (int16)servokonum*30+100;
   }
   
}

} 
